Debian Bug report logs - #509815
ITA: libiodbc2 -- iODBC Driver Manager

version graph

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Bart Martens <bartm@knars.be>

Date: Fri, 26 Dec 2008 18:18:04 UTC

Owned by: Maximiliano Curia <maxy@debian.org>

Severity: normal

Fixed in version libiodbc2/3.52.8-1

Done: Maximiliano Curia <maxy@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#509815; Package wnpp. (Fri, 26 Dec 2008 18:18:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bart Martens <bartm@knars.be>:
New Bug report received and forwarded. Copy sent to <wnpp@debian.org>. (Fri, 26 Dec 2008 18:18:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Bart Martens <bartm@knars.be>
To: submit@bugs.debian.org
Subject: O: libiodbc2 -- iODBC Driver Manager
Date: Fri, 26 Dec 2008 19:16:29 +0100
Package: wnpp

http://packages.qa.debian.org/libi/libiodbc2.html






Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#509815; Package wnpp. (Fri, 26 Aug 2011 08:25:23 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Fri, 26 Aug 2011 08:25:23 GMT) Full text and rfc822 format available.

Message #10 received at 509815@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: 639300@bugs.debian.org
Cc: 639300-submitter@bugs.debian.org, Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>, Christoph Berg <myon@debian.org>, 509815@bugs.debian.org
Subject: Re: odbc-postgresql: can't be installed together with KDE any more
Date: Fri, 26 Aug 2011 01:17:43 -0700
[Message part 1 (text/plain, inline)]
reassign 639300 soprano
retitle 639300 please build against unixodbc-dev instead of libiodbc2-dev
thanks

Hi folks,

This week with Christoph Berg's help, unixodbc has been converted for
multiarch in unstable along with the common drivers: libmyodbc, tdsodbc, and
odbc-postgresql.  The converted drivers are now all installed in
/usr/lib/<arch>/odbc, and the /etc/odbcinst.ini config has been updated to
use relative paths instead of absolute ones.

libiodbc2, which has been orphaned for nearly three years, has *not* been
updated for multiarch, and so libiodbc will fail to locate these drivers on
disk.  As a result, these drivers declare a Breaks: against libiodbc2.

I do not intend to update libiodbc2 for multiarch.  Instead, I would like to
propose its removal from the archive.  Historically, we have carried both
unixodbc and libiodbc2 in the archive to avoid a circular build-dependency:
Qt build-depends on ODBC for its database support, and UnixODBC
build-depends on Qt for its GUI tools.  The most recent upstream version of
UnixODBC resolves this, because in addition to being updated for Qt4, the
latest upstream release also splits the GUI tools into a separate source
distribution, which I have just uploaded to unstable.

So I am reassigning this bug to soprano.  KDE maintainers, please switch
soprano to build against unixodbc-dev instead of libiodbc2-dev.

(I will file separate bugs against the other reverse-dependencies, but for
soprano someone has beaten me to it.)

Thanks,
-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
Ubuntu Developer                                    http://www.debian.org/
slangasek@ubuntu.com                                     vorlon@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#509815; Package wnpp. (Sat, 19 Nov 2011 13:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "glpk xypron" <xypron.glpk@gmx.de>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Sat, 19 Nov 2011 13:18:03 GMT) Full text and rfc822 format available.

Message #15 received at 509815@bugs.debian.org (full text, mbox):

From: "glpk xypron" <xypron.glpk@gmx.de>
To: Steve Langasek <vorlon@debian.org>, 639300@bugs.debian.org, 509815@bugs.debian.org, 598787@bugs.debian.org
Subject: libiodbc2 -- iODBC Driver Manager orphaned
Date: Sat, 19 Nov 2011 14:14:56 +0100
Hello Steve,

> This week with Christoph Berg's help, unixodbc has been converted for
> multiarch in unstable along with the common drivers: libmyodbc,
> tdsodbc, and odbc-postgresql.  The converted drivers are now all installed in
> /usr/lib/<arch>/odbc, and the /etc/odbcinst.ini config has been updated to
> use relative paths instead of absolute ones.
>
> libiodbc2, which has been orphaned for nearly three years, has *not* been
> updated for multiarch, and so libiodbc will fail to locate these drivers on
> disk.  As a result, these drivers declare a Breaks: against libiodbc2.

I guess the problem is not about iODBC finding shared drivers like
libmyodbc. Instead a driver build against unixODBC is not compatible
with one build against iODBC. See bug #598787.

This means if both iODBC and unixODBC are kept, separate packages
for libmyodbc are needed.

I have had a look at the upstream.

http://unixodbc.svn.sourceforge.net/
shows active development.

http://iodbc.cvs.sourceforge.net/viewvc/iodbc/iODBC/iodbc/
shows no activity since 2009.

I guess the next step should be to ask the upstream author
of iODBC, if iODBC will be supported in future.

Best regards

Xypron

-- 
NEU: FreePhone - 0ct/min Handyspartarif mit Geld-zurück-Garantie!		
Jetzt informieren: http://www.gmx.net/de/go/freephone




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#509815; Package wnpp. (Sat, 19 Nov 2011 19:36:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Sat, 19 Nov 2011 19:36:12 GMT) Full text and rfc822 format available.

Message #20 received at 509815@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: glpk xypron <xypron.glpk@gmx.de>
Cc: 639300@bugs.debian.org, 509815@bugs.debian.org, 598787@bugs.debian.org
Subject: Re: libiodbc2 -- iODBC Driver Manager orphaned
Date: Sat, 19 Nov 2011 11:35:23 -0800
[Message part 1 (text/plain, inline)]
On Sat, Nov 19, 2011 at 02:14:56PM +0100, glpk xypron wrote:
> > This week with Christoph Berg's help, unixodbc has been converted for
> > multiarch in unstable along with the common drivers: libmyodbc,
> > tdsodbc, and odbc-postgresql.  The converted drivers are now all installed in
> > /usr/lib/<arch>/odbc, and the /etc/odbcinst.ini config has been updated to
> > use relative paths instead of absolute ones.

> > libiodbc2, which has been orphaned for nearly three years, has *not* been
> > updated for multiarch, and so libiodbc will fail to locate these drivers on
> > disk.  As a result, these drivers declare a Breaks: against libiodbc2.

> I guess the problem is not about iODBC finding shared drivers like
> libmyodbc.

You guess wrong.  I put the Breaks there, I'm telling you why they were
added.

> Instead a driver build against unixODBC is not compatible with one build
> against iODBC.  See bug #598787.

The lack of 100% compatibility between iODBC and unixODBC is another issue;
it's one that could be solved if there were a good reason to keep two ODBC
driver managers in the archive, but there isn't.  Thus we should just get
rid of libiodbc; but this is currently blocked on soprano's lack of
compatibility with unixodbc.

> This means if both iODBC and unixODBC are kept, separate packages
> for libmyodbc are needed.

That will absolutely never happen.

> I guess the next step should be to ask the upstream author
> of iODBC, if iODBC will be supported in future.

No, the next step is to figure out how to fix soprano, and then remove iODBC
from the archive.

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
Ubuntu Developer                                    http://www.debian.org/
slangasek@ubuntu.com                                     vorlon@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#509815; Package wnpp. (Tue, 29 Nov 2011 00:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Patrick van Kleef <iodbc@openlinksw.com>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Tue, 29 Nov 2011 00:15:06 GMT) Full text and rfc822 format available.

Message #25 received at 509815@bugs.debian.org (full text, mbox):

From: Patrick van Kleef <iodbc@openlinksw.com>
To: glpk xypron <xypron.glpk@gmx.de>
Cc: 509815@bugs.debian.org
Subject: Re: Dropping iODBC from Debian/Ubuntu, see Debian bug #509815
Date: Tue, 29 Nov 2011 00:56:41 +0100
Hi Heinrich,

> in Debian bug #509815 there is an open discussion to drop
> iODBC from Debian (which will result in dropping it from
> Ubuntu).
> 
> Looking at the iODBC.org and the iodbc.sourceforge site
> there seems to have been no new developments in the last
> two years.
> 
> Do you plan to further support and develop iODBC?

The short answer is yes on both accounts.

First of all we do support iODBC and the ODBC API in general actively both towards our own customers as well as the general public who have questions on how to use ODBC API in their own or third party applications as well as assist in debugging issues relating to both open source and commercial drivers. We have an active support system in place for anyone with questions, bugreports etc to go to, as well as mailing lists, forums etc hosted by sourceforge.net.

We actively assist other open-source projects to enhance their ODBC offering, for instance the code changes we contributed to PHP project to both 5.2.x and 5.3.x branches to allow their ext/odbc code to fully work in 64bit mode which up to 5.2.6 was completely impossible. We also fixed the handling of the various ODBC Cursor models in the PHP code. Another project we are currently actively involved in is KDE/Soprano/Nepomuk, which uses another open-source product from us called Virtuoso which is also available on most platforms including Debian and Ubuntu. We also advised them on the usage of ODBC in general, not specifically towards the use of iODBC.

As for new developments go, please note that the ODBC spec has been stagnant after Microsoft finished the last big revision (the 3.52 in 1997-1998) which we implemented. As we have no intentions to add new API functions itself as long as these will not be available for Windows. For a long time Microsoft pushed people to ditch ODBC in favor of ADO, however there are rumors that they are going to revive the ODBC standard which we hope will bring some enhancements to the areas that were not well defined/explained in the last standard. We continue to track developments in this area and when this calls for fixes/additions to the iODBC driver manager code, we will of course make them.

However we are working on one extension to the ODBC standard which deals with UNICODE support. In all of their documentation Microsoft was very vague about the definition and use of SQLWCHAR, especially when it comes to non-Windows platforms. So when we interpreted the standard, we mapped it to the platform native wchar_t which seemed to make the most sense at the time since this would allow C, C++ to define the size and it should work with the native libraries in a portable manner. OpenLink's own ODBC drivers were programmed to do the translation between internal formats of the db (ucs2, ucs4, utf8 etc) to the platform native format which is 16bit wide on Windows (using UTF16 encoding), and 32bit wide on most UNIX platforms (using UTF-32). Note that the specs indicate this translation lies with the driver.

This approach allowed the user to use standard constructs like:

	SQLHANDLE hstmt;
	SQLWCHAR * my_cmd;

	....

	my_cmd = L"select * from account";
	SQLPrepareW (hstmt, my_cmd, SQL_NTS);

which works on both Microsoft and Unix platforms.

However other projects (like unixODBC and QT) chose at some point to use a 2byte UTF-16 encoded multibyte equivalent for portability on all platforms, which means that all ascii strings need to be converted before they can be used. For the ODBC standard this means that translation needs to be done within the application, instead of the driver. 

In light of this we started to make an addition to the existing iODBC driver manager code to allow the driver manager to work in both 2 and 4 byte mode at both ends (application and driver). Development is not going as fast as i would like, since other commercial developments have a higher priority, but we are currently trying to iron out the last bugs before release. 


As for having both unixODBC and iODBC concurrently on a platform, i see no reason why this would be any problem for the runtime parts since they do not overlap at all. There is a potential problem with the location of the header files, but we could easily change this for debian (or any other system) to be installed in /usr/include/iodbc and add the -I/usr/include/iodbc to the iodbc-config script. 


There are many libraries and programs providing similar functionality in any distribution, allowing the users a choice which they want to use.

One of the features a lot of iODBC users like is the fact that it very readable trace logs containing both both symbolic and values for all arguments which allows the user to better understand the sequence of instructions that are send to the driver and the return values which may influence the behavior of their application.


I welcome anyone to contact me if they have questions about iODBC or any other OpenLink product, and i hope i am allowed to participate in this discussion for the continued shipment of iODBC on the Debian platform.


Best regards,

Patrick
---
Patrick van Kleef
Manager Open Source Projects
OpenLink Software
















Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#509815; Package wnpp. (Mon, 16 Apr 2012 20:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Patrick van Kleef <iodbc@openlinksw.com>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Mon, 16 Apr 2012 20:03:02 GMT) Full text and rfc822 format available.

Message #30 received at 509815@bugs.debian.org (full text, mbox):

From: Patrick van Kleef <iodbc@openlinksw.com>
To: 509815@bugs.debian.org
Subject: iODBC project moved to GitHub
Date: Mon, 16 Apr 2012 21:32:14 +0200
All,

Please be aware that the iODBC project has been converted from CVS to GIT and now is available from GitHub:

	http://github.com/openlink/iODBC

Note that the current version of iODBC is v3.52.8.

We would like to get in touch with someone in the Debian community to get this version packaged and updated to use the multiarch approach. We will examine the changes to the build scripts for unixODBC to see what exactly has been done and see if we can fix our build files similarly.

Patrick
---
Maintainer iODBC



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#509815; Package wnpp. (Mon, 11 Mar 2013 21:27:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Maximiliano Curia <maxy@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Mon, 11 Mar 2013 21:27:09 GMT) Full text and rfc822 format available.

Message #35 received at 509815@bugs.debian.org (full text, mbox):

From: Maximiliano Curia <maxy@debian.org>
To: 509815@bugs.debian.org, control@bugs.debian.org
Subject: The KDE Team intends to adopt libiodbc2
Date: Mon, 11 Mar 2013 22:22:43 +0100
[Message part 1 (text/plain, inline)]
retitle 509815 ITA: libiodbc2 -- iODBC Driver Manager
owner 509815 !
thanks

Hi,

Currently libiodbc2 is needed by a great part of KDE, the team currently
maintains the soprano db, so libiodbc2 is a sort of missing link. Also, by
mainting this packages we intend to fix #639300.

Thanks,
Happy Hacking.
-- 
"The cheapest, fastest and most reliable components of a computer system are
those that aren't there."
-- Gordon Bell
Saludos /\/\ /\ >< `/
[signature.asc (application/pgp-signature, inline)]

Changed Bug title to 'ITA: libiodbc2 -- iODBC Driver Manager' from 'O: libiodbc2 -- iODBC Driver Manager' Request was from Maximiliano Curia <maxy@debian.org> to control@bugs.debian.org. (Mon, 11 Mar 2013 21:27:12 GMT) Full text and rfc822 format available.

Owner recorded as Maximiliano Curia <maxy@debian.org>. Request was from Maximiliano Curia <maxy@debian.org> to control@bugs.debian.org. (Mon, 11 Mar 2013 21:27:13 GMT) Full text and rfc822 format available.

Reply sent to Maximiliano Curia <maxy@debian.org>:
You have taken responsibility. (Thu, 06 Jun 2013 09:21:23 GMT) Full text and rfc822 format available.

Notification sent to Bart Martens <bartm@knars.be>:
Bug acknowledged by developer. (Thu, 06 Jun 2013 09:21:23 GMT) Full text and rfc822 format available.

Message #44 received at 509815-close@bugs.debian.org (full text, mbox):

From: Maximiliano Curia <maxy@debian.org>
To: 509815-close@bugs.debian.org
Subject: Bug#509815: fixed in libiodbc2 3.52.8-1
Date: Thu, 06 Jun 2013 09:19:55 +0000
Source: libiodbc2
Source-Version: 3.52.8-1

We believe that the bug you reported is fixed in the latest version of
libiodbc2, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 509815@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Maximiliano Curia <maxy@debian.org> (supplier of updated libiodbc2 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Thu, 06 Jun 2013 09:06:37 +0200
Source: libiodbc2
Binary: iodbc libiodbc2 libiodbc2-dev
Architecture: source amd64
Version: 3.52.8-1
Distribution: experimental
Urgency: low
Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
Changed-By: Maximiliano Curia <maxy@debian.org>
Description: 
 iodbc      - GTK+ config frontend for the iODBC Driver Manager
 libiodbc2  - iODBC Driver Manager
 libiodbc2-dev - iODBC Driver Manager (development files)
Closes: 509815
Changes: 
 libiodbc2 (3.52.8-1) experimental; urgency=low
 .
   * New upstream release.
   * New maintainer. (Closes: #509815)
   * Bump debhelper build-dep and compat to 9.
   * Migrate packaging to dh.
   * Bump Standards-Version to 3.9.4.
   * Add symbols files.
   * Update install files for multi-arch.
   * Update install files.
   * Add Pre-Depends for multi-arch.
   * Update lintian-overrides.
   * Remove duplicate section field.
   * Update libiodbc2-dev install file, remove private libraries.
   * Change includedir to avoid conflicts.
   * Install pkgconfig file.
   * Add Multi-Arch: same to libiodbc2.
Checksums-Sha1: 
 bb4ad3aeb06ca5cfd090c708abd1ef3b72abb85a 1959 libiodbc2_3.52.8-1.dsc
 93a3f061afff3152c5fcee1e5af8b802760a7e74 1089784 libiodbc2_3.52.8.orig.tar.gz
 03c780005946f2b8edc3dd8c0a1133f525f2c8cb 11493 libiodbc2_3.52.8-1.debian.tar.gz
 57f49ece09f7c7bc36061bda67d6fbe5d547a8fa 282754 iodbc_3.52.8-1_amd64.deb
 5c2e13bb3c03f34dc8fb3a8393b266000dac30ed 198792 libiodbc2_3.52.8-1_amd64.deb
 3b153a14c78d15020e8983684a26b5dbe46c3703 67658 libiodbc2-dev_3.52.8-1_amd64.deb
Checksums-Sha256: 
 c9a28877218a662a09e11d114c3ad0041d1787f8ad02e7d36c88aa52fd471906 1959 libiodbc2_3.52.8-1.dsc
 18165501fbdb5ab8c445d07365907b77c0c20887aecf37ed2b88aacd9c59129a 1089784 libiodbc2_3.52.8.orig.tar.gz
 753a473b31c1f02bd16dff12de8b00b28bf3c3051323ae29ba0af51c8de2be35 11493 libiodbc2_3.52.8-1.debian.tar.gz
 9d9cc182e719dc21ae6438f900083b104a0f09cf61a3b46f414ccc7386aef7f5 282754 iodbc_3.52.8-1_amd64.deb
 b663db779e99fa3e3db32ab6e14c87c915417c635cbc91c06b31abb7f2c4f00d 198792 libiodbc2_3.52.8-1_amd64.deb
 4beb3fece4e5a835e62fa344512585af12c41586a755ef728b15cc5758df0f3c 67658 libiodbc2-dev_3.52.8-1_amd64.deb
Files: 
 847a6958ea19550d13428d6484943a1d 1959 libs optional libiodbc2_3.52.8-1.dsc
 9889f95f632f10895ff53b8a22162810 1089784 libs optional libiodbc2_3.52.8.orig.tar.gz
 c38a33305f74087af41ba462973e987d 11493 libs optional libiodbc2_3.52.8-1.debian.tar.gz
 c3161f4ebf1e24818e8b2f27b81b9ca0 282754 misc optional iodbc_3.52.8-1_amd64.deb
 af56353eb373bb743bbc878549680b56 198792 libs optional libiodbc2_3.52.8-1_amd64.deb
 e362c33e1ae77df07e8bf771399c18c2 67658 libdevel optional libiodbc2-dev_3.52.8-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJRsEEMAAoJEMcZdpmymyMq8nYP/2GqokU/4YhHDnd3oxeVaGCe
BjqRVppknbQ/cROAEEct9kObtVC621+TM5hM3/GCuZ+9hwO+lFedtCGYuAIosxSe
EwqZDgAOwAxmK7C+kymjkAAS0TISrwayc+yxf7WqBuAaaVoGkoAL5SMAmFUkcFtR
aaKwtM5e8mUi76RkRau1vzLFITr1mjx9DuPvjNuwV9Tx/VHELgIKU7CR9ajjoyPN
f8JGE/iS5eiRYmm+ikUD8YOQcup02oCJ8DE9dCsUsOi1EubmrxhNgzlfnSglAPBm
1+V8DhwNP6+1NGrFspZYXZTqlHC7GkcJcILFNMB0t1NIM01cJ0wg82DJFd6XuXl7
kzErzKyd+uGNXvdRcsGYqOYcy5F0sO+3S9jZCtAseYaPE1wnCd+ZYfN5Dk9FfoDL
PGBaXKthGp//NlJ0K3bilm+A7MduF3KjNaEi2nRRfSt8c1lF/tMeLdBanBd183Ao
MoDD4u1rWxnzCK8E1s24+LuWddPDIwmG+t+t2Sn2bYZs9yL4olKhpwvbk1VHdcHk
GGrbD6nWhizeS52koA3senuGnIGjikQar22b9bz3ZwINTL9S0GpaaAgE3+HEKK5h
MTAMw9srPkruf7DlngvjFCITMMPzlIEyQcFppJOtnrQDiuxvbwyYWHCI3DpbZeEb
sId/Tr6dV3LhI2vVdRBJ
=aV9V
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 05 Jul 2013 07:27:06 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 09:54:22 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.